<template>
  <div>
    <transition name="slide" mode="out-in">
      <div v-if="$route.name === 'shop'">
        <div class="card mb-4" v-for="product of products" :key="product.id">
          <div class="row">
            <div class="col-md-4">
              <img :src="`http://localhost:5000/uploads/${product.photo}`"
                   class="card-img" alt=""/>
            </div>
            <div class="col-md-8">
              <div class="card-body">
                <h5 class="card-text">{{ product.productName }}</h5>
                <small class="text-muted d-block">{{ product.timestamp._seconds | dateAgo }}</small>
                <p class="card-text">{{ product.description }}</p>
                <router-link class="card-link" :to="{ name: 'detail', params: { id: product.id }}">
                  <button class="btn btn-primary">Details</button>
                </router-link>
              </div>
            </div>
          </div>
        </div>
      </div>
    </transition>
    <transition name="slide" mode="out-in">
      <router-view></router-view>
    </transition>
  </div>
</template>

<script>
import ProductService from "../../services/product.service";

export default {
  data() {
    return {
      products: []
    }
  },
  created() {
    this.products = this.$route.meta.products;
  },
  beforeRouteUpdate(to, from, next) {
    if (to.path === '/shop' && from.path === '/shop/add') {
      this.products = [];
      ProductService.getProducts().subscribe(res => {
            this.setData(res.data.data);
            next();
          },
          err => console.log(err)
      )
    }
    next();
  },
  methods: {
    setData(product) {
      this.products = product;
    }
  }
}
</script>
